#	UserGroups ViewNews Addon
#	by plushpuffin@wwddfd.com
#	http://www.wwddfd.com
#
##############################################
##############################################
##############################################
#
# Define all user/group information fields
#
#
# you must define the following for each
# field you wish to access with viewsnews:
#
# for user properties:
# 1) $uField{'FIELD'} = q~Description~;
#
# for group properties:
# 2) $gField{'FIELD'} = q~Description~;
#
# optional, for special fields which
# retrieve their properties in a special way:
# *) $ugGetProperty{'FIELD'} = q~Subroutine~;
#
#
$gField{'USR'} = q~Users in Group~;
$gField{'DESC'} = q~Group Description~;
$uField{'ICQ'} = q~ICQ Number~;
$uField{'URL'} = q~Home Page~;
#
#
##############################################
##############################################
##############################################

$uggloaded = 0;
$upploaded = 0;
$ugBuild = 16;
push(@Addons_ViewNews_Handler,'UGStartup');

##############################################
# Get SPECIFICALLY DECLARED property for the user or group
#		USAGE: &ugVar( GROUPNAME/USERNAME, VARIABLENAME )
#
sub ugVar {
	&UGStartup;
	my ( $thegroup, $whichvar ) = @_;
	my ($result) = $usergroups{$thegroup}->{$whichvar} =~ m~$whichvar:(.*)~;
	return $result;
}

##############################################
# Get INHERITED property for the user or group
#		USAGE: &inheritedVar( USERNAME, VARIABLENAME )
#
sub inheritedVar {
	my ($theuser, $whichvar ) = @_;
	&UGStartup;
	unless( $upploaded ) { &AssembleAllUsersProperties; }
	my ($result) = $propsusers{$theuser}->{$whichvar} =~ m~$whichvar:(.*)~;
	return $result;
}

##############################################
# Get the user's property for specific field from ALL groups (collective)
#		(NO PARAMATERS PASSED)
#		expects the variables $theuser and $gfield to be defined
#
sub ugGetProperties {
	&UGStartup;
	my $thegroup;
	my (%all_props,@props,$props);
	my $userfind;
	@props = split(/\|x\|/, &ugVar($theuser,$gfield));
	foreach $prop (@props) {
		$all_props{$prop} = 1;
	}
	foreach $thegroup (@groups) {
		$userfind = '|x|' . &ugVar($thegroup,'USR') . '|x|';
		unless( $userfind =~ m~\|$theuser\|~ || $userfind =~ m~\|AllUsers\|~ ) { next; }
		if( $usergroups{$thegroup}->{$gfield} ) {
			@props = split(/\|x\|/, &ugVar($thegroup,$gfield));
			foreach $prop (@props) {
				$all_props{$prop} = 1;
			}
		}
	}
	return join( '|x|', keys %all_props );
}

##############################################
# Get the user's property for specific field from the first group with that property
#		(NO PARAMATERS PASSED)
#		expects the variables $theuser and $gfield to be defined
#
sub ugGetProperty {
	&UGStartup;
	local $thegroup;
	my $userfind;
	if( exists $usergroups{$theuser}->{$gfield} ) { return &ugVar($theuser,$gfield); }
	foreach $thegroup (@groups) {
		$userfind = '|x|' . &ugVar($thegroup,'USR') . '|x|';
		unless( $userfind =~ m~\|$theuser\|~ || $userfind =~ m~\|AllUsers\|~ ) { next; }
		if( $usergroups{$thegroup}->{$gfield} ) {
			return &ugVar($thegroup,$gfield);
		}
	}
}

##############################################
# FIRST TIME ONLY
# Call UserGroupsLoadConfig
# FIRST TIME ONLY
#
#		(NO PARAMATERS PASSED)
#
sub UGStartup
{
	unless( $uggloaded ) { &UserGroupsLoadConfig; }
}

#############################################
# Load from ugsettings.cgi
#		(NO PARAMATERS PASSED)
#		Also, assemble all user properties for
#		faster access...
#
sub UserGroupsLoadConfig
{
	&UGReadHashFile(\%usergroups,'ugsettings.cgi');
	$uggloaded = 1;
	&AssembleAllUsersProperties;
}

##############################################
# Read hash from the file nsetname
#		USAGE: &UGReadHashFile( \%HASHREFERENCE, FILENAME )
#		(*) separates properties
#		``x separates the user/group name and the list of properties
#		|x| acts as the delimiter in all lists
#
sub UGReadHashFile
{
	my ( $hashref, $nsetname ) = @_;
	my ( $varname, $varvalue, @varr, $nsetpath );
	if ($abspath)
	{
		$nsetpath = "$abspath/";
	}
	$nsetpath .= $nsetname;
	if( -d $nsetpath ) { &NPdie(qq~UserGroups can't find or access file $nsetpath because
		there is a directory in the specified location by the same name~); }
	unless( -e $nsetpath ) { NPopen('NPCFG', ">$nsetpath"); print NPCFG '';close(NPCFG); }
	NPopen('NPCFG', $nsetpath);
	my @gdom = <NPCFG>;
	close(NPCFG);
	foreach $i (@gdom)
	{
		($varname, $varvalue) = split(/``x/, $i);
		$varvalue =~ s/^\s+//;
		$varvalue =~ s/\s+$//;
		$varvalue =~ s/\n//g;
		$varval =~ s/` ` x/``x/g;
		@varr = split( /\(\*\)/, $varvalue );
		$$hashref{$varname} = ();
		foreach $k (@varr)
		{
			$k =~ m~(.*?):.*~o;
			$$hashref{$varname}->{$1} = $k;
		}
	}
}

##############################################
# Assemble all properties for all users
#		(NO PARAMATERS PASSED)
#
sub AssembleAllUsersProperties {
	local @gfields = sort keys %gField;
	local @groups = ();
	my $group;
	&UGStartup;
	foreach $group (sort keys %usergroups) {
		unless( $CPassword{$group} ) {
			push( @groups, $group );
		}
	}
	my $theuser;
	foreach $theuser (@usernames) {
		$propsusers{$theuser} = ();
		&assembleTheUsersProperties($theuser);
	}
	$upploaded = 1;
	foreach $gfield (keys %uField) {
		if( $gField{$gfield} ) { next; }
		$groupval = &ugVar($Cookies{'uname'},$gfield);
		${"UGV_$gfield"} = $groupval;
		tie ${"UGP_$gfield"}, 'Tie::UGPROP', $gfield, 'ugVar', $NPConfig{'UGPField'};
	}
	foreach $gfield (keys %gField) {
		unless( $uField{$gfield} ) { next; }
		$groupval = &inheritedVar($Cookies{'uname'},$gfield);
		${"UGV_$gfield"} = $groupval;
		tie ${"UGP_$gfield"}, 'Tie::UGPROP', $gfield, 'inheritedVar', $NPConfig{'UGPField'};
	}
}

##############################################
# Assemble all properties for a single user by 'borrowing' from
#		the groups containing that user
#		USAGE: &assembleTheUsersProperties( USERNAME )
#
sub assembleTheUsersProperties {
	&UGStartup;
	local $theuser = shift;
	local $gfield;
	my $groupval;
	foreach $gfield (@gfields) {
		unless( $uField{$gfield} ) { next; }
		if( $ugGetProperty{$gfield} ) {
			eval { $groupval = &{$ugGetProperty{$gfield}}; };
			if ($@) {
				&NPdie("Error running addon subroutine $ugGetProperty{$gfield} from the usergroups addon. If you continue to experience this error, remove the addon which is responsible for that subroutine. Error: $@");
			}
		}
		else { $groupval = &ugGetProperty; }
		if( defined $groupval ) {
			#print qq~\n<HR>$theuser : $gfield == $groupval<BR>\n~;
			$propsusers{$theuser}->{$gfield} = "$gfield:$groupval";
			#print qq~\n$propsusers{$theuser}->{$gfield}<HR>\n~;
		}
		else {
			delete $propsusers{$theuser}->{$gfield};
		}
	}
}

unless( $NPConfig{'UGPField'} ) {
	$NPConfig{'UGPField'} = 'newsname';
}
1;
#####################################################
package Tie::UGPROP;
sub TIESCALAR {
	my $class = shift;
	my $self = [@_];
	return bless $self => $class;
}

sub FETCH {
	my $self = $_[0];
	return &{"main::$$self[1]"}( ${"main::$$self[2]"}, $$self[0] );
}

sub STORE {
	return;
}

sub DESTROY {
	my $self = $_[0];
	@$self = ();
}
1;
#####################################################